<?php declare(strict_types=1);

namespace App\Domains\Driver\Action;

use App\Domains\Core\Action\ActionFactoryAbstract;
use App\Domains\Driver\Model\Driver as Model;

class ActionFactory extends ActionFactoryAbstract
{
    protected ?Model $row;

    public function create(): Model
    {
        return $this->actionHandle(Create::class, $this->validate()->create());
    }

    /**
     * @return void
     */
    public function delete(): void
    {
        $this->actionHandle(Delete::class);
    }

    public function update(): Model
    {
        return $this->actionHandle(Update::class, $this->validate()->update());
    }

    public function updateAlarm(): Model
    {
        return $this->actionHandle(UpdateAlarm::class, $this->validate()->updateAlarm());
    }

    public function updateDevice(): Model
    {
        return $this->actionHandle(UpdateDevice::class, $this->validate()->updateDevice());
    }
}
