<?php declare(strict_types=1);

namespace App\Domains\Driver\Action;

use App\Domains\Device\Model\Device as DeviceModel;
use App\Domains\Driver\Model\Driver as Model;

class UpdateDevice extends ActionAbstract
{
    public function handle(): Model
    {
        $this->data();
        $this->save();

        return $this->row;
    }

    /**
     * @return void
     */
    protected function data(): void
    {
        $this->data['related'] = DeviceModel::query()
            ->byUserId($this->row->user_id)
            ->byIds($this->data['related'])
            ->pluck('id')
            ->all();
    }

    /**
     * @return void
     */
    protected function save(): void
    {
        $this->saveUnrelate();
        $this->saveRelate();
    }

    /**
     * @return void
     */
    protected function saveUnrelate(): void
    {
        DeviceModel::query()
            ->byDriverId($this->row->id)
            ->update(['driver_id' => null]);
    }

    /**
     * @return void
     */
    protected function saveRelate(): void
    {
        if (empty($this->data['related'])) {
            return;
        }

        DeviceModel::query()
            ->byIds($this->data['related'])
            ->update(['driver_id' => $this->row->id]);
    }
}
