<?php declare(strict_types=1);

namespace App\Domains\Driver\Controller;

use Illuminate\Http\Response;
use App\Domains\Driver\Service\Controller\UpdateAlarmNotification as ControllerService;

class UpdateAlarmNotification extends ControllerAbstract
{
    /**
     * @param int $id
     *
     * @return \Illuminate\Http\Response
     */
    public function __invoke(int $id): Response
    {
        $this->row($id);

        $this->meta('title', __('driver-update-alarm-notification.meta-title', ['title' => $this->row->name]));

        return $this->page('driver.update-alarm-notification', $this->data());
    }

    /**
     * @return array
     */
    protected function data(): array
    {
        return ControllerService::new($this->request, $this->auth, $this->row)->data();
    }
}
