<?php declare(strict_types=1);

namespace App\Domains\Driver\Model\Builder;

use App\Domains\CoreApp\Model\Builder\BuilderAbstract;
use App\Domains\Trip\Model\Trip as TripModel;

class Driver extends BuilderAbstract
{
    /**
     * @return self
     */
    public function listSimple(): self
    {
        return $this->select('id', 'name')->orderBy('name', 'ASC');
    }

    /**
     * @return self
     */
    public function selectRelated(): self
    {
        return $this->selectOnly('id', 'name', 'license', 'user_id');
    }

    /**
     * @return self
     */
    public function selectSimple(): self
    {
        return $this->select('id', 'name', 'license', 'enabled', 'user_id');
    }

    /**
     * @param ?bool $finished
     *
     * @return self
     */
    public function whenTripFinished(?bool $finished): self
    {
        return $this->when(is_bool($finished), fn ($q) => $q->whereTripFinished($finished));
    }

}
