<?php declare(strict_types=1);

namespace App\Domains\Driver\Service\Controller;

use Illuminate\Contracts\Auth\Authenticatable;
use Illuminate\Http\Request;
use App\Domains\Driver\Model\Driver as Model;
use App\Domains\Driver\Model\Collection\Driver as Collection;

class Index extends ControllerAbstract
{
    /**
     * @var bool
     */
    protected bool $userEmpty = true;

    /**
     * @param \Illuminate\Http\Request $request
     * @param \Illuminate\Contracts\Auth\Authenticatable $auth
     *
     * @return self
     */
    public function __construct(protected Request $request, protected Authenticatable $auth)
    {
        $this->filters();
    }

    /**
     * @return void
     */
    protected function filters(): void
    {
        $this->filtersUserId();
    }

    /**
     * @return array
     */
    public function data(): array
    {
        return $this->dataCore() + [
            'list' => $this->list(),
        ];
    }

    protected function list(): Collection
    {
        return $this->cache(
            fn () => Model::query()
                //->whenUserId($this->user()?->id)
                ->withUser()
                ->list()
                ->get()
        );
    }
}
